function [a,beta,fstein,v,vq,ETp] = decwavsureletbt(wrc,jm,sw,wavname,sigmab,Gam,Vwb,Gamt,Kappa,alpha,indp,rt,Gb)
% [a,beta,fstein,v,vq,ETp] = decwavsureletbt(wrc,jm,sw,wavname,sigmab,Gam,Vwb,Gamt,Kappa,alpha,indp,rt,Gb)
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************

N = sw(end,1);
M = sw(end,2);

if nargin == 12
    Gb = ones(N,M);
end
Gb(indp) = 0;

mim = 6*jm+1;
beta = zeros(mim,N,M);
f = zeros(mim,1);
v = zeros(mim,1);
vq = zeros(mim,mim);

Nr = N*M/2^(2*jm);
iw0 = Nr;
ind = 1:iw0;
wrct = zeros(size(wrc));
wrct(ind) = wrc(ind);
betat = waverec2(wrct,sw,wavname);
betat = real(ifft2(Gb.*fft2(betat)));
beta(1,:,:) = betat;
f(1) = -sigmab^2*Gam(1)*Nr;
v(1) = Kappa(1)*Nr;
vq(1,1) = Gamt(1)*Nr;
ETp(1,1) = 1;
ETp(1,2) = 0;
ETp(1,3) = 0;
mi = 2;
fprintf(1,'j = ');
for j = 1:jm
    fprintf(1,'%d    ',j);
    for d = 1:3 % d =1 : H, 2 : V, 3 : D
        ind = iw0+Nr*(d-1)+1:iw0+Nr*d;
        wrct = zeros(size(wrc));
        wrct(ind) = wrc(ind);
        betat = waverec2(wrct,sw,wavname);
        betat = real(ifft2(Gb.*fft2(betat)));
        beta(mi,:,:) = betat;
        f(mi) = -sigmab^2*Gam((mi+2)/2)*Nr;
        v(mi) = Kappa((mi+2)/2)*Nr;
        vq(mi,mi) = Gamt((mi+2)/2)*Nr;
        ETp((mi+2)/2,1) = 1;
        mi = mi+1;
        sigmawb = sigmab*sqrt(Vwb((mi+1)/2));
        betat = waverec2(fblu(wrct,alpha*sigmawb),sw,wavname);
        betat = real(ifft2(Gb.*fft2(betat)));
        beta(mi,:,:) = betat;
        swrc = sum(dfblu(wrc(ind),alpha*sigmawb));
        ETp((mi+1)/2,2) = swrc/Nr;
        swrc2 = sum(dfblu(wrc(ind),alpha*sigmawb).^2);
        ETp((mi+1)/2,3) = (swrc2/Nr-swrc^2/Nr^2)*Gam((mi+1)/2)^2*Nr;
        f(mi) = -sigmab^2*Gam((mi+1)/2)*swrc;
        v(mi) = Kappa((mi+1)/2)*swrc;
        vq(mi,mi) = Gam((mi+1)/2)^2*(swrc2-swrc^2/Nr)+ Gamt((mi+1)/2)*swrc^2/Nr;
        vq(mi,mi-1) = Gamt((mi+1)/2)*swrc;
        vq(mi-1,mi) = vq(mi,mi-1);
        mi = mi+1;
    end
    iw0 = ind(end);
    Nr = Nr*4;
end
fprintf(1,'\n');

fstein = -2*f;

betaM = zeros(mim,mim);
for mi = 1:mim
    f(mi) = f(mi)+sum(sum(squeeze(beta(mi,:,:)).*rt));
    for mi2 = mi:mim
        betaM(mi,mi2) = sum(sum(beta(mi,:,:).*beta(mi2,:,:)));
        
        if mi2 ~= mi
            betaM(mi2,mi) = betaM(mi,mi2);
        end
    end
end

a = pinv(betaM)*f;