function T = freqfilt2D(t,N,M,st)
% T = freqfilt2D(t,N,M,st)
%
% From kernel t to frequency response T
% (blur)
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************

if nargin == 3
    st = 0;
end

[L1,L2] = size(t);

t = (1+st*(2*rand(L1,L2)-1)).*t;

T = zeros(N,M);
L12 = ceil(L1/2);
L22 = ceil(L2/2);
T(1:L12,1:L22) = t(L12:L1,L22:L2);
T(N-L12+2:N,1:L22) = t(1:L12-1,L22:L2);
T(1:L12,M-L22+2:M) = t(L12:L1,1:L22-1);
T(N-L12+2:N,M-L22+2:M) = t(1:L12-1,1:L22-1);

T = fft2(T);