function xp = projfour(x,indp,H)
% xp = projfour(x,indp,H)
%
% Projector
% Eqs. (23),(28) of
% A SURE Approach for Digital Signal/Image Deconvolution Problems
% Jean-Christophe Pesquet, Amel Benazza-Benyahia, Caroline Chaux
% IEEE Transactions on Signal Processing, Vol. 57, No. 12, Dec. 2009, pp.
% 4616-4632.
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************

X = fft2(x);
X(indp) = 0;

if nargin ~= 2
    H(indp) = 1;
    X = X./H;
end

xp = real(ifft2(X));
