function sigmab = setbsnr(bsnr,xc)
% sigmab = setbsnr(bsnr,xc)
%
% Compute the noise standard deviation sigmab to achieve the fixed bsnr
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************

[N,M] = size(xc);

sigmab = 10^(-bsnr/20)*norm(xc,'fro')/sqrt(N*M);
